angular.module('gaugesScreen', [])

  .controller('GaugesScreenController', function ($scope, $element, $window) {
    "use strict";
    var vm = this;

    var svg;
    var navContainer = $element[0].children[0];
    var navDimensions = [];

    var gauge = { gears: {} };
    var tacho = {  };
    var infoDisplay = {};
    var roots = {};
    var electrics = {lights:{} };
    var gagues = {fuel:{},temp:{}};


    var speedoInitialised = true;
    var currentGear = '';

    var ready = false;

    var unit = "metric";
    var unitspeedConv = 2.23694;


    // Make sure SVG is loaded
    $scope.onSVGLoaded = function () {
        console.log("onSVGLoaded");
      svg = $element[0].children[0].children[0];


      gauge.speedValue = hu('#speedo_txt', svg);
      gauge.tachoValue = hu('#rpm_val', svg);

      //roots.speedo_bar = hu('#speedo_bar', svg);
      roots.tacho = hu('#tach_on', svg);
      roots.shiftLights = hu('#shift_on', svg);
      roots.fuel = hu('#fuel_val', svg);
      roots.watt = hu('#watt_val', svg);
      roots.oilt = hu('#oilt_val', svg);
      roots.volt = hu('#volt_val', svg);

      ready = true;
    }


    function fixClock(v, fill="0"){
      return (v<10)? fill+v : v;
    }

    function temperature(input) {
      return (input*1.8)+32;
    }

    /*function updateSpeedDisplays(data) {
      let speed = data.electrics.wheelspeed * unitspeedConv
      gauge.speedValue.text((speed ).toFixed(0));

      let children = roots.speedo_bar.n.childNodes
      for (let i = 0; i < children.length; i++) {//lucky that the order of elements are ok
        children[i].style.display = (speed > i*2.72)?"inline":"none";
      }

    }*/

    function updateTachoDisplays(data) {
      let rpm = Math.round(data["electrics"]["rpmTacho"]);
      gauge.tachoValue.text(rpm);
      let children = roots.tacho.n.childNodes
      for (let i = children.length-1; i >= 0; i--) {
        let index = parseInt(children[i].id.replace("tacho_",""));
        children[i].style.display = (rpm >= index*100)?"inline":"none";
      }
    }

    function updateShiftLights(data) {
      let rpm = Math.round(data["electrics"]["rpmTacho"]);
      let children = roots.shiftLights.n.childNodes
      for (let i = children.length-1; i >= 0; i--) {
        let index = parseInt(children[i].id.replace("shift_light_",""));
        children[i].style.display = (rpm >= index*100)?"inline":"none";
      }
    }

    function limitVal(min, val,max){
        return Math.min(Math.max(min,val), max);
    }

    function updateGagueFuel(data) {
      let fuel = data.electrics.fuel;
      let fuelp = 70.5
      fuelp *= (1 - ((1 - fuel) ** 10))
      roots.fuel.text(fuelp.toFixed(1));
    }

    function updateGagueTemp(data) {
      let temp = data.electrics.watertemp;
      roots.watt.text(temperature(temp).toFixed(0));
    }

    function updateOilTemp(data) {
      let val = data.electrics.oiltemp;
      roots.oilt.text(temperature(val).toFixed(0));
    }

    function updateBattery(data) {
      let val = (data.electrics.engineRunning>0.5)? 14.5: 12.5;//fake voltage
      //min 8, max 16 V
      val-=8;
      roots.volt.text(val.toFixed(1));
    }

    // overwriting plain javascript function so we can access from within the controller
    $window.setup = (data) => {
      if(!ready){
        console.log("calling setup while svg not fully loaded");
        setTimeout(function(){ $window.setup(data) }, 100);
        return;
      }

      //console.log("setup",data);

    }


    $window.updateData = (data) => {
      if (data) {
        if(!ready){console.log("not ready");return;}
        // console.log(data);

        // Update Speed displays
        //updateSpeedDisplays(data);
        updateTachoDisplays(data);
        updateShiftLights(data);

        //updateElectrics(data);
        updateGagueFuel(data);
        updateGagueTemp(data);
        updateOilTemp(data);
        updateBattery(data);
      }
    }
    //ready = true;
  });